import React from 'react';
import { ComponentProps, UseAsyncPaginateParams } from 'react-select-async-paginate';
import { NamedProps } from 'react-select';
import { GroupTypeBase } from 'react-select/src/types';
import { TPageLoadResponse, TPageParams } from 'AppModels';
declare type Props<OptionType, Additional, isMulti extends boolean> = Omit<UseAsyncPaginateParams<OptionType, Additional>, 'loadOptions'> & Omit<NamedProps<OptionType, isMulti, GroupTypeBase<OptionType>>, 'loadOptions'> & ComponentProps & {
    fetchDataFn: (search: string, pageParams?: TPageParams) => Promise<TPageLoadResponse<OptionType[]>>;
    label?: React.ReactNode;
    setValue: (value: isMulti extends true ? OptionType[] : OptionType) => void;
    valueKey?: string;
    labelKey?: string;
    error?: boolean;
    helperText?: string;
};
declare function AppAsyncPaginateSelect<OptionType extends Record<string, any>, isMulti extends boolean = false>(props: Props<OptionType, {
    page: number;
}, isMulti>): JSX.Element;
export default AppAsyncPaginateSelect;
