/// <reference types="react" />
import { UseAsyncPaginateParams } from 'react-select-async-paginate';
import { NamedProps } from 'react-select';
import { GroupTypeBase } from 'react-select/src/types';
import { TPageLoadResponse, TPageParams } from 'AppModels';
declare type Props<OptionType, Additional, isMulti extends boolean> = Omit<UseAsyncPaginateParams<OptionType, Additional>, 'loadOptions'> & Omit<NamedProps<OptionType, isMulti, GroupTypeBase<OptionType>>, 'loadOptions'> & {
    fetchDataFn: (search: string, pageParams?: TPageParams) => Promise<TPageLoadResponse<OptionType[]>>;
    label?: string;
    name: string;
    valueKey?: string;
    labelKey?: string;
};
declare function AppValidateAsyncSelect<OptionType, isMultiple extends boolean = false>(props: Props<OptionType, {
    page: number;
}, isMultiple>): JSX.Element;
export default AppValidateAsyncSelect;
