import { c as createMuiTheme } from './emotion-element-547f2a0a.esm-e310ff83.js';

var defaultTheme = createMuiTheme();
var MuiTheme = createMuiTheme({
    palette: {
        primary: {
            main: '#38B4C9',
            dark: '#2DA6BA',
            light: '#7BC9B1',
        },
        secondary: {
            main: '#7BC9B1',
        },
        error: {
            main: '#E16145',
        },
    },
    typography: {
        fontFamily: 'Roboto',
        htmlFontSize: 10,
    },
    components: {
        MuiInputLabel: {
            styleOverrides: {
                shrink: {
                    transform: 'translate(0, 1.5px) scale(0.75)',
                },
            },
        },
        MuiButton: {
            variants: [
                {
                    props: { variant: 'dashed' },
                    style: {
                        textTransform: 'none',
                        border: "2px dashed " + defaultTheme.palette.primary.main,
                        color: defaultTheme.palette.primary.main,
                    },
                },
                {
                    props: { variant: 'dashed', color: 'secondary' },
                    style: {
                        border: "2px dashed " + defaultTheme.palette.secondary.main,
                        color: defaultTheme.palette.secondary.main,
                    },
                },
                {
                    props: { variant: 'dashed', size: 'large' },
                    style: {
                        borderWidth: 4,
                    },
                },
                {
                    props: { variant: 'dashed', color: 'secondary', size: 'large' },
                    style: {
                        fontSize: 18,
                    },
                },
            ],
            defaultProps: {
                variant: 'contained',
                color: 'primary',
            },
            styleOverrides: {
                contained: {
                    color: 'white',
                },
                disableElevation: {
                    cursor: 'default',
                },
            },
        },
        MuiTextField: {
            defaultProps: {
                variant: 'standard',
            },
        },
        MuiSvgIcon: {
            styleOverrides: {
                fontSizeSmall: {
                    fontSize: '1.5rem',
                },
            },
        },
        MuiFormLabel: {
            styleOverrides: {
                root: {
                    color: 'inherit',
                },
            },
        },
        MuiTypography: {
            styleOverrides: {
                body1: {
                    fontSize: '1.6rem',
                },
            },
        },
    },
});

export { MuiTheme as M };
//# sourceMappingURL=MuiTheme-1e22e0bd.js.map
