import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import React, { useCallback, useRef, useState, useEffect } from 'react';
import EditIcon from '@material-ui/icons/Edit';
import { IconButton, TextField, MenuItem } from '@material-ui/core';
import SaveIcon from '@material-ui/icons/Save';
import ClearIcon from '@material-ui/icons/Clear';
import { s as styles$1 } from '../../EditableCell.module-359afc02.js';
import { s as styles } from '../../EnhancedTable.module-3f17e3a7.js';
import { useDispatch } from 'react-redux';
import { b as setTableSelectable } from '../../actions-469e4403.js';
import '../../style-inject.es-1f59c1d0.js';

var EditableCellSelectField = function (props) {
    var dispatch = useDispatch();
    var setSelectable = useCallback(function (value) {
        dispatch(setTableSelectable(value));
    }, [dispatch]);
    var initialValue = props.value, column = props.column, row = props.row, label = props.label, options = props.options, _a = props.valueKey, valueKey = _a === void 0 ? 'value' : _a, _b = props.labelKey, labelKey = _b === void 0 ? 'label' : _b;
    var inputEl = useRef(null);
    var divEl = useRef(null);
    var _c = useState(false), open = _c[0], setOpen = _c[1];
    var _d = React.useState(initialValue), value = _d[0], setValue = _d[1];
    useEffect(function () {
        if (inputEl.current) {
            inputEl.current.focus();
        }
    }, [open, inputEl]);
    var setEdit = function () {
        setOpen(true);
        setSelectable(true);
    };
    var updateData = function () {
        if (props.handleUpdate) {
            props.handleUpdate(value);
        }
        if (column.editData) {
            column.editData(row.original, value, column.id);
        }
        setOpen(false);
        setSelectable(false);
    };
    function cancel() {
        setValue(initialValue);
        setOpen(false);
        setSelectable(false);
    }
    var submitForm = function (event) {
        event.preventDefault();
        updateData();
        setSelectable(false);
    };
    React.useEffect(function () {
        setValue(initialValue);
    }, [initialValue]);
    var handleChange = function (event) {
        setValue(event.target.value);
    };
    return (jsx("div", __assign({ ref: divEl }, { children: !open ? (jsxs("div", __assign({ className: "dflex" }, { children: [jsxs("span", __assign({ className: "capitalize" }, { children: [label || initialValue, " "] }), void 0),
                jsx(IconButton, __assign({ className: styles.displayOnHover, size: "small", onClick: function () { return setEdit(); } }, { children: jsx(EditIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)) : (jsx("form", __assign({ onSubmit: submitForm }, { children: jsxs("div", __assign({ className: styles$1.inputContainer }, { children: [jsx(TextField, __assign({ select: true, value: value, onChange: handleChange, SelectProps: {
                            IconComponent: 'span',
                            MenuProps: {
                                anchorOrigin: {
                                    vertical: 'bottom',
                                    horizontal: 'left',
                                },
                                getContentAnchorEl: null,
                            },
                        } }, { children: options.map(function (option) { return (jsx(MenuItem, __assign({ value: option[valueKey] }, { children: option[labelKey] }), option[valueKey])); }) }), void 0),
                    jsxs("span", __assign({ className: styles$1.formButton }, { children: [jsx(IconButton, __assign({ size: "small", onClick: updateData }, { children: jsx(SaveIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0),
                            jsx(IconButton, __assign({ size: "small", onClick: function () { return cancel(); } }, { children: jsx(ClearIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)] }), void 0) }), void 0)) }), void 0));
};

export default EditableCellSelectField;
//# sourceMappingURL=EditableCellSelectField.js.map
