import { _ as __assign, d as __spreadArray } from '../../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import React, { useCallback, useRef, useState, useEffect } from 'react';
import EditIcon from '@material-ui/icons/Edit';
import { IconButton, Autocomplete } from '@material-ui/core';
import ClearIcon from '@material-ui/icons/Clear';
import { s as styles } from '../../EditableCell.module-359afc02.js';
import { s as styles$1 } from '../../EnhancedTable.module-3f17e3a7.js';
import { useDispatch } from 'react-redux';
import { b as setTableSelectable } from '../../actions-469e4403.js';
import DoneRoundedIcon from '@material-ui/icons/DoneRounded';
import AppTextField from '../../TextField/AppTextField.js';
import '../../style-inject.es-1f59c1d0.js';

var EditableCellSelectMultipleField = function (props) {
    var dispatch = useDispatch();
    var setSelectable = useCallback(function (value) {
        dispatch(setTableSelectable(value));
    }, [dispatch]);
    var initialValue = props.value, column = props.column, row = props.row, label = props.label, options = props.options, _a = props.valueKey, valueKey = _a === void 0 ? 'value' : _a, _b = props.labelKey, labelKey = _b === void 0 ? 'label' : _b;
    var inputEl = useRef(null);
    var divEl = useRef(null);
    var _c = useState(false), open = _c[0], setOpen = _c[1];
    var _d = React.useState(initialValue), listLabel = _d[0], setListLabel = _d[1];
    var _e = React.useState([]), listValue = _e[0], setListValue = _e[1];
    useEffect(function () {
        if (inputEl.current) {
            inputEl.current.focus();
        }
    }, [open, inputEl]);
    var setEdit = function () {
        setOpen(true);
        setSelectable(true);
    };
    var updateData = function () {
        if (column.editData) {
            column.editData(row.original, listValue);
        }
        setOpen(false);
        setSelectable(false);
    };
    function cancel() {
        setListLabel(initialValue);
        setOpen(false);
        setSelectable(false);
    }
    useEffect(function () {
        if (open) {
            setListLabel(initialValue);
        }
    }, [open]);
    var submitForm = function (event) {
        event.preventDefault();
        updateData();
        setSelectable(false);
    };
    return (jsx("div", __assign({ className: styles.cellWrap, ref: divEl }, { children: !open ? (jsxs("div", __assign({ className: styles.dflex }, { children: [jsxs("span", { children: [label || initialValue, " "] }, void 0),
                jsx(IconButton, __assign({ className: styles$1.displayOnHover, size: "small", onClick: function () { return setEdit(); } }, { children: jsx(EditIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)) : (jsx("form", __assign({ className: styles.multipleSelect, onSubmit: submitForm }, { children: jsxs("div", __assign({ className: styles.inputContainer }, { children: [jsx(Autocomplete, { classes: {
                            root: styles.autocompleteRoot,
                            inputRoot: styles.autocompleteInputRoot,
                            input: styles.autocompleteInput,
                        }, value: options.filter(function (item) { return listLabel.indexOf(item[labelKey]) > -1; }), multiple: true, options: options, disableClearable: true, getOptionLabel: function (option) { return option[labelKey]; }, renderInput: function (params) { return (jsx(AppTextField, __assign({ classes: {
                                root: styles.autocompleteTextForm,
                            } }, params, { autoFocus: true, InputLabelProps: { required: true } }), void 0)); }, onChange: function (event, listLabel) {
                            setListLabel(listLabel.reduce(function (acc, item) { return __spreadArray(__spreadArray([], acc), [item[labelKey]]); }, []));
                            setListValue(listLabel.reduce(function (acc, item) { return __spreadArray(__spreadArray([], acc), [item[valueKey]]); }, []));
                        }, clearOnBlur: true, freeSolo: true, size: "small", openOnFocus: true }, void 0),
                    jsxs("span", __assign({ className: styles.formButton }, { children: [jsx(IconButton, __assign({ size: "small", onClick: updateData }, { children: jsx(DoneRoundedIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0),
                            jsx(IconButton, __assign({ size: "small", onClick: function () { return cancel(); } }, { children: jsx(ClearIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)] }), void 0) }), void 0)) }), void 0));
};

export default EditableCellSelectMultipleField;
//# sourceMappingURL=EditableCellSelectMultipleField.js.map
