import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import React, { useCallback, useRef, useState, useEffect } from 'react';
import { u as useOnClickOutside } from '../../useOnClickOutside-5fbcb3ab.js';
import '../../ResizeObserver-da68295b.js';
import EditIcon from '@material-ui/icons/Edit';
import { IconButton } from '@material-ui/core';
import ClearIcon from '@material-ui/icons/Clear';
import { s as styles } from '../../EditableCell.module-359afc02.js';
import { s as styles$1 } from '../../EnhancedTable.module-3f17e3a7.js';
import { useDispatch } from 'react-redux';
import { b as setTableSelectable } from '../../actions-469e4403.js';
import DoneRoundedIcon from '@material-ui/icons/DoneRounded';
import '../../style-inject.es-1f59c1d0.js';

var EditableCellTextField = function (props) {
    var dispatch = useDispatch();
    var setSelectable = useCallback(function (value) {
        dispatch(setTableSelectable(value));
    }, [dispatch]);
    var initialValue = props.value, column = props.column, row = props.row, inputProps = props.inputProps;
    var inputEl = useRef(null);
    var divEl = useRef(null);
    var _a = useState(false), open = _a[0], setOpen = _a[1];
    var _b = React.useState(initialValue), value = _b[0], setValue = _b[1];
    useOnClickOutside(divEl, function () { return cancel(); });
    useEffect(function () {
        if (inputEl.current) {
            inputEl.current.focus();
        }
    }, [open, inputEl]);
    var onChange = function (event) {
        setValue(event.target.value);
    };
    var setEdit = function () {
        setOpen(true);
        setSelectable(true);
    };
    var updateData = function () {
        if (props.handleUpdate) {
            props.handleUpdate(value);
        }
        if (column.editData) {
            column.editData(row.original, value, column.id);
        }
        setOpen(false);
        setSelectable(false);
    };
    function cancel() {
        setValue(initialValue);
        setOpen(false);
        setSelectable(false);
    }
    var submitForm = function (event) {
        event.preventDefault();
        updateData();
        setSelectable(false);
    };
    useEffect(function () {
        setValue(initialValue);
    }, [initialValue]);
    return (jsx("div", __assign({ ref: divEl }, { children: !(column.canEdit && open) ? (jsxs("div", __assign({ className: styles.dflex }, { children: [jsx("span", { children: props.children || initialValue }, void 0),
                column.canEdit && (jsx(IconButton, __assign({ className: styles$1.displayOnHover, size: "small", onClick: function () { return setEdit(); } }, { children: jsx(EditIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0))] }), void 0)) : (jsx("form", __assign({ onSubmit: submitForm }, { children: jsxs("div", __assign({ className: styles.inputContainer }, { children: [jsx("input", __assign({ ref: inputEl, type: "text", value: value, onChange: onChange, onClick: function () { return setEdit(); } }, inputProps), void 0),
                    jsxs("span", __assign({ className: styles.formButton }, { children: [jsx(IconButton, __assign({ type: 'submit', size: "small" }, { children: jsx(DoneRoundedIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0),
                            jsx(IconButton, __assign({ size: "small", onClick: function () { return cancel(); } }, { children: jsx(ClearIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)] }), void 0) }), void 0)) }), void 0));
};

export default EditableCellTextField;
//# sourceMappingURL=EditableCellTextField.js.map
