import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import { useCallback, useRef, useState, useEffect } from 'react';
import TodayIcon from '@material-ui/icons/Today';
import AppTextField from '../../TextField/AppTextField.js';
import { DatePicker } from '@material-ui/lab';
import ClearIcon from '@material-ui/icons/Clear';
import { g as getDatabaseFormatType, a as getDatabaseFormatDate } from '../../moment-b7e0efe6.js';
import { IconButton } from '@material-ui/core';
import DoneRoundedIcon from '@material-ui/icons/DoneRounded';
import { s as styles } from '../../EditableCell.module-359afc02.js';
import { s as styles$1 } from '../../EnhancedTable.module-3f17e3a7.js';
import EditIcon from '@material-ui/icons/Edit';
import { u as useOnClickOutside } from '../../useOnClickOutside-5fbcb3ab.js';
import '../../ResizeObserver-da68295b.js';
import { useDispatch } from 'react-redux';
import { b as setTableSelectable } from '../../actions-469e4403.js';
import '../../style-inject.es-1f59c1d0.js';
import '../../_commonjsHelpers-318dc0aa.js';

var EditableDate = function (props) {
    var dispatch = useDispatch();
    var setSelectable = useCallback(function (value) {
        dispatch(setTableSelectable(value));
    }, [dispatch]);
    var row = props.row, _a = props.inputTimeFormat, inputTimeFormat = _a === void 0 ? 'MM/DD/YYYY' : _a;
    var divEl = useRef(null);
    useOnClickOutside(divEl, function () { return cancelTimePicker(); });
    var _b = useState(false), editDate = _b[0], setEditDate = _b[1];
    var _c = useState(row.value), selectedDate = _c[0], setSelectedDate = _c[1];
    function openTimePicker() {
        setEditDate(true);
        setSelectable(true);
    }
    function cancelTimePicker() {
        setSelectedDate(row.value);
        setEditDate(false);
    }
    useEffect(function () {
        setSelectedDate(row.value);
    }, [row.value]);
    function updateData() {
        if (row.column.editData) {
            row.column.editData(row.row.original, selectedDate, row.column.id);
        }
        setEditDate(false);
    }
    return (jsx("div", __assign({ className: styles.formEditableDateTime }, { children: !editDate ? (jsxs("span", { children: [getDatabaseFormatType(selectedDate, inputTimeFormat),
                jsx(IconButton, __assign({ className: styles$1.displayOnHover, size: "small", onClick: openTimePicker }, { children: jsx(EditIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }, void 0)) : (jsx(DatePicker, { openTo: "year", value: selectedDate, onChange: function (newVal) {
                setSelectedDate(getDatabaseFormatDate(newVal));
            }, openPickerIcon: jsx(TodayIcon, { color: 'secondary' }, void 0), inputFormat: inputTimeFormat, clearable: true, renderInput: function (props) {
                var _a;
                return (jsx(AppTextField, __assign({}, props, { InputLabelProps: { shrink: true }, InputProps: __assign(__assign({}, props.InputProps), { endAdornment: (jsxs("div", __assign({ className: styles.formButton }, { children: [(_a = props.InputProps) === null || _a === void 0 ? void 0 : _a.endAdornment,
                                jsx(IconButton, __assign({ size: "small", onClick: updateData }, { children: jsx(DoneRoundedIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0),
                                jsx(IconButton, __assign({ size: "small", onClick: function () { return cancelTimePicker(); } }, { children: jsx(ClearIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)) }), helperText: false }), void 0));
            } }, void 0)) }), void 0));
};

export default EditableDate;
//# sourceMappingURL=EditableDate.js.map
