import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import { useCallback, useRef, useState } from 'react';
import { createMuiTheme } from '@material-ui/core/styles';
import TodayIcon from '@material-ui/icons/Today';
import AppTextField from '../../TextField/AppTextField.js';
import { DateTimePicker } from '@material-ui/lab';
import ClearIcon from '@material-ui/icons/Clear';
import { b as getDatabaseFormatDateTime } from '../../moment-b7e0efe6.js';
import { IconButton } from '@material-ui/core';
import DoneRoundedIcon from '@material-ui/icons/DoneRounded';
import { s as styles } from '../../EditableCell.module-359afc02.js';
import { s as styles$1 } from '../../EnhancedTable.module-3f17e3a7.js';
import EditIcon from '@material-ui/icons/Edit';
import { u as useOnClickOutside } from '../../useOnClickOutside-5fbcb3ab.js';
import '../../ResizeObserver-da68295b.js';
import { useDispatch } from 'react-redux';
import { b as setTableSelectable } from '../../actions-469e4403.js';
import '../../style-inject.es-1f59c1d0.js';
import '../../_commonjsHelpers-318dc0aa.js';

var defaultTheme = createMuiTheme();
var MuiTheme = createMuiTheme({
    palette: {
        primary: {
            main: '#38B4C9',
            dark: '#2DA6BA',
            light: '#7BC9B1',
        },
        secondary: {
            main: '#7BC9B1',
        },
        error: {
            main: '#E16145',
        },
    },
    typography: {
        fontFamily: 'Roboto',
        htmlFontSize: 10,
    },
    components: {
        MuiInputLabel: {
            styleOverrides: {
                shrink: {
                    transform: 'translate(0, 1.5px) scale(0.75)',
                },
            },
        },
        MuiButton: {
            variants: [
                {
                    props: { variant: 'dashed' },
                    style: {
                        textTransform: 'none',
                        border: "2px dashed " + defaultTheme.palette.primary.main,
                        color: defaultTheme.palette.primary.main,
                    },
                },
                {
                    props: { variant: 'dashed', color: 'secondary' },
                    style: {
                        border: "2px dashed " + defaultTheme.palette.secondary.main,
                        color: defaultTheme.palette.secondary.main,
                    },
                },
                {
                    props: { variant: 'dashed', size: 'large' },
                    style: {
                        borderWidth: 4,
                    },
                },
                {
                    props: { variant: 'dashed', color: 'secondary', size: 'large' },
                    style: {
                        fontSize: 18,
                    },
                },
            ],
            defaultProps: {
                variant: 'contained',
                color: 'primary',
            },
            styleOverrides: {
                contained: {
                    color: 'white',
                },
                disableElevation: {
                    cursor: 'default',
                },
            },
        },
        MuiTextField: {
            defaultProps: {
                variant: 'standard',
            },
        },
        MuiSvgIcon: {
            styleOverrides: {
                fontSizeSmall: {
                    fontSize: '1.5rem',
                },
            },
        },
        MuiFormLabel: {
            styleOverrides: {
                root: {
                    color: 'inherit',
                },
            },
        },
        MuiTypography: {
            styleOverrides: {
                body1: {
                    fontSize: '1.6rem',
                },
            },
        },
    },
});

var EditableDateTime = function (props) {
    var dispatch = useDispatch();
    var setSelectable = useCallback(function (value) {
        dispatch(setTableSelectable(value));
    }, [dispatch]);
    var row = props.row, inputTimeFormat = props.inputTimeFormat;
    var divEl = useRef(null);
    useOnClickOutside(divEl, function () { return cancelTimePicker(); });
    var _a = useState(false), editDate = _a[0], setEditDate = _a[1];
    var _b = useState(row.value), selectedDate = _b[0], setSelectedDate = _b[1];
    function openTimePicker() {
        setEditDate(true);
        setSelectable(true);
    }
    function cancelTimePicker() {
        setSelectedDate(row.value);
        setEditDate(false);
    }
    function updateData() {
        if (row.column.editData) {
            row.column.editData(row.row.original, selectedDate, row.column.id);
        }
        setEditDate(false);
    }
    return (jsx("div", __assign({ className: styles.formEditableDateTime }, { children: !editDate ? (jsxs("span", { children: [getDatabaseFormatDateTime(selectedDate),
                jsx(IconButton, __assign({ className: styles$1.displayOnHover, size: "small", onClick: openTimePicker }, { children: jsx(EditIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }, void 0)) : (jsx(DateTimePicker, { value: selectedDate, onChange: function (newVal) {
                setSelectedDate(getDatabaseFormatDateTime(newVal));
            }, desktopModeMediaQuery: MuiTheme.breakpoints.up('sm'), openPickerIcon: jsx(TodayIcon, { color: 'secondary' }, void 0), inputFormat: inputTimeFormat, ampmInClock: true, clearable: true, renderInput: function (props) {
                var _a;
                return (jsx(AppTextField, __assign({}, props, { InputLabelProps: { shrink: true }, InputProps: __assign(__assign({}, props.InputProps), { endAdornment: (jsxs("div", __assign({ className: styles.formButton }, { children: [(_a = props.InputProps) === null || _a === void 0 ? void 0 : _a.endAdornment,
                                jsx(IconButton, __assign({ size: "small", onClick: updateData }, { children: jsx(DoneRoundedIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0),
                                jsx(IconButton, __assign({ size: "small", onClick: function () { return cancelTimePicker(); } }, { children: jsx(ClearIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)) }), helperText: false }), void 0));
            } }, void 0)) }), void 0));
};

export default EditableDateTime;
//# sourceMappingURL=EditableDateTime.js.map
