import { d as __spreadArray, _ as __assign } from '../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import { useEffect, useCallback, useRef, useState } from 'react';
import { r as reactTable } from '../index-1c6562bc.js';
import { useSticky } from './plugins/useSticky.js';
import TableContainer from '@material-ui/core/TableContainer';
import TableToolbar from './Toolbar/TableToolbar.js';
import { s as styles } from '../EnhancedTable.module-3f17e3a7.js';
import { c as clsx } from '../clsx.m-6243b874.js';
import { S as SelectableGroup, R as RowSelectable } from '../RowSelectable-641d33ed.js';
import ReactTablePagination from './Pagination/ReactTablePagination.js';
import { C as ContextMenu, a as ContextMenuTrigger } from '../connectMenu-dd4dca1c.js';
import '../index-ae06fe64.js';
import ConditionalWrap from '../utils/ConditionalWrap.js';
import { Backdrop, CircularProgress, Toolbar } from '@material-ui/core';
import { useLocation, useHistory } from 'react-router-dom';
import { g as getFilters, a as getRouterQueries, l as lib, b as getPage, c as getPageSize } from '../GlobalFilter-1efc032d.js';
import { c as config } from '../config-2233d325.js';
import { useDispatch, useSelector } from 'react-redux';
import { s as selectMultiRows } from '../actions-469e4403.js';
import { g as getStorageInitialState, u as useMainResize, t as tableSelectableSelector } from '../useMainResize-11da9592.js';
import { d as debounce_1 } from '../debounce-8e349d2c.js';
import selectionHook from './plugins/selectionHook.js';
import EditableCellTextField from './EditableCell/EditableCellTextField.js';
import TableHeader from './components/TableHeader.js';
import { S as SELECTION_COLUMN_ID } from '../constants-cdb4cae7.js';
import { useLocalStorageTable } from './plugins/useLocalStorageTable.js';
import { useHiddenColumn } from './plugins/useHiddenColumn.js';
import App from '../App.js';
import '../_commonjsHelpers-318dc0aa.js';
import '@material-ui/core/Toolbar';
import './Toolbar/ColumnDisplay.js';
import '@material-ui/icons/ViewColumn';
import '@material-ui/icons/ArrowDropDown';
import '../isEqual-ff64fdde.js';
import '../_MapCache-42897023.js';
import '../_isIndex-e6cb62f4.js';
import './Toolbar/FilterBox.js';
import '@material-ui/icons/FilterAlt';
import './Toolbar/LocalGlobalFilter.js';
import '@material-ui/core/styles';
import '@material-ui/core/InputBase';
import '@material-ui/core/IconButton';
import '@material-ui/icons/Search';
import '../lodash-5bd42e57.js';
import '../useOnClickOutside-5fbcb3ab.js';
import '@material-ui/core/Tooltip/Tooltip';
import '@material-ui/icons/HighlightOff';
import '../style-inject.es-1f59c1d0.js';
import './Pagination/TablePaginationActions.js';
import '@material-ui/icons/FirstPage';
import '@material-ui/icons/KeyboardArrowLeft';
import '@material-ui/icons/KeyboardArrowRight';
import '@material-ui/icons/LastPage';
import '../TextField/AppTextField.js';
import '../get-45a0ceab.js';
import '../_baseSet-5f342bb5.js';
import '../ResizeObserver-da68295b.js';
import '../Checkbox/AppCheckBox.js';
import '@material-ui/icons/Check';
import '@material-ui/icons/Remove';
import '@material-ui/icons/Edit';
import '@material-ui/icons/Clear';
import '../EditableCell.module-359afc02.js';
import '@material-ui/icons/DoneRounded';
import '../slicedToArray-cde334b7.js';
import 'react-dom';

function useChangeLocationQuery(instance, fetchData) {
    var setAllFilters = instance.setAllFilters, _a = instance.state, pageIndex = _a.pageIndex, pageSize = _a.pageSize, sortBy = _a.sortBy, filters = _a.filters;
    var location = useLocation();
    var history = useHistory();
    useEffect(function () {
        var currentQuery = getFilters(location.search);
        setAllFilters(currentQuery);
    }, [location.search, setAllFilters]);
    var fetchDataDebounce = reactTable.useAsyncDebounce(function () {
        var currentQuery = getRouterQueries(location.search);
        var query = {};
        if (Object.keys(filters).length) {
            query.filter = filters.reduce(function (obj, item) {
                obj[item.id] = item.value;
                return obj;
            }, {});
        }
        if (Object.keys(sortBy).length) {
            query.sort = sortBy.reduce(function (obj, item) {
                obj[item.id] = item.desc ? 'desc' : 'asc';
                return obj;
            }, {});
        }
        if (pageIndex) {
            query.page = pageIndex + 1;
        }
        if (pageSize !== config.perPage)
            query.per_page = pageSize;
        if (currentQuery.search && typeof currentQuery.search === 'string') {
            query.search = currentQuery.search;
        }
        var search = lib.stringify(query);
        var currentSearch = lib.stringify(currentQuery);
        if (search === currentSearch) {
            if (fetchData) {
                fetchData(query);
            }
            return;
        }
        else {
            history.push({
                search: search,
            });
        }
    }, 100);
    useEffect(function () {
        fetchDataDebounce();
    }, [pageIndex, pageSize, filters, sortBy, location, fetchDataDebounce]);
}

var defaultColumn = {
    Cell: EditableCellTextField,
};
var EnhancedTable = function (props) {
    var _a;
    var _b;
    var columns = props.columns, data = props.data, rightClickMenu = props.rightClickMenu, toolbarItems = props.toolbarItems, isLoading = props.isLoading, fetchData = props.fetchData, pageInfo = props.pageInfo, localStorageKey = props.localStorageKey, _c = props.useSelection, useSelection = _c === void 0 ? true : _c, _d = props.useBlockingOverlay, useBlockingOverlay = _d === void 0 ? true : _d, overlayConfig = props.overlayConfig, alignItemsCenter = props.alignItemsCenter, _e = props.defaultHiddenColumns, defaultHiddenColumns = _e === void 0 ? [] : _e;
    var location = useLocation();
    var pageUrl = getPage(location.search);
    var filterUrl = getFilters(location.search);
    var initState = getStorageInitialState(localStorageKey);
    if (!initState.hiddenColumns && defaultHiddenColumns.length > 0) {
        initState.hiddenColumns = defaultHiddenColumns;
    }
    var instance = reactTable.useTable.apply(void 0, __spreadArray([{
            columns: columns,
            tableKey: localStorageKey,
            data: data,
            defaultColumn: defaultColumn,
            initialState: __assign({ pageIndex: pageUrl ? pageUrl - 1 : 0, pageSize: getPageSize(location.search) || config.perPage, filters: filterUrl }, initState),
            manualSortBy: true,
            manualFilters: true,
            manualPagination: true,
            pageCount: 100,
        }, reactTable.useFlexLayout,
        reactTable.useResizeColumns,
        reactTable.useFilters,
        reactTable.useColumnOrder,
        reactTable.useGlobalFilter,
        reactTable.useSortBy,
        reactTable.usePagination,
        reactTable.useRowSelect,
        useSticky,
        useLocalStorageTable,
        useHiddenColumn], (useSelection ? [selectionHook] : [])));
    var getTableProps = instance.getTableProps, prepareRow = instance.prepareRow, page = instance.page, gotoPage = instance.gotoPage, setPageSize = instance.setPageSize, selectedFlatRows = instance.selectedFlatRows, toggleAllRowsSelected = instance.toggleAllRowsSelected, rows = instance.rows, _f = instance.state, pageIndex = _f.pageIndex, pageSize = _f.pageSize;
    var mainWidth = useMainResize().width;
    var stableColumns = __spreadArray([
        SELECTION_COLUMN_ID
    ], instance.allColumns
        .filter(function (item) { return item.isStable; })
        .map(function (item) { return item.id; }));
    var dispatch = useDispatch();
    useChangeLocationQuery(instance, fetchData);
    var delayedQuery = useCallback(debounce_1(function (rows) {
        dispatch(selectMultiRows(rows));
    }, 500), [dispatch]);
    useEffect(function () {
        var rows = selectedFlatRows.map(function (item) { return item.original; });
        delayedQuery(rows);
    }, [delayedQuery, selectedFlatRows]);
    var tableRef = useRef(null);
    useEffect(function () {
        if (tableRef.current) {
            tableRef.current.scrollIntoView({ behavior: 'smooth' });
        }
    }, [pageIndex, pageSize]);
    var Pagination = (jsx(ReactTablePagination, { gotoPage: gotoPage, pageIndex: pageIndex, setPageSize: setPageSize, pageSize: pageSize, pageTotal: pageInfo.total }, void 0));
    var isSelectable = useSelector(tableSelectableSelector);
    var _g = useState(null), previousRow = _g[0], setPreviousRow = _g[1];
    var handleSelectableGroupFinish = function (selectedRows) {
        if (selectedRows && selectedRows.length > 0) {
            selectedRows.forEach(function (row) {
                if (row && row.props) {
                    row.props.row.toggleRowSelected();
                }
            });
        }
    };
    return (jsx(App, { children: jsxs(TableContainer, __assign({ className: clsx(styles.tableContainer, useBlockingOverlay &&
                !(overlayConfig === null || overlayConfig === void 0 ? void 0 : overlayConfig.displayFullscreen) &&
                styles.positionRelative), style: { width: instance.totalVisibleColumnsWidth } }, { children: [jsx(Backdrop, __assign({ className: clsx(styles.backdrop, (_b = overlayConfig === null || overlayConfig === void 0 ? void 0 : overlayConfig.displayFullscreen) !== null && _b !== void 0 ? _b : styles.positionAbsolute), open: !!isLoading && useBlockingOverlay }, { children: jsx(CircularProgress, { color: "inherit" }, void 0) }), void 0),
                jsx(TableToolbar, { width: mainWidth, instance: instance, stableColumns: stableColumns, toolbarItems: toolbarItems, pagination: Pagination, defaultHiddenColumns: defaultHiddenColumns }, void 0),
                jsx("div", __assign({ className: styles.actionScroll }, { children: jsxs(SelectableGroup, __assign({ className: styles.fixWidthScroll, selectboxClassName: 'selectable-selectbox', disabled: isSelectable, deselectOnEsc: true, selectOnClick: false, enableDeselect: true, allowClickWithoutSelected: false, tolerance: 5, resetOnStart: true, onSelectionFinish: handleSelectableGroupFinish, ignoreList: ['.th'] }, { children: [rightClickMenu && (jsx(ContextMenu, __assign({ id: "same_unique_identifier", className: styles.contextMenu }, { children: rightClickMenu }), void 0)),
                            jsx("div", __assign({ className: clsx(styles.tableBodyScroll, styles.noHighLight) }, { children: jsx(ConditionalWrap, __assign({ condition: !!rightClickMenu, wrap: function (children) { return (jsx(ContextMenuTrigger, __assign({ id: 'same_unique_identifier', holdToDisplay: -1 }, { children: children }), void 0)); } }, { children: jsxs("div", __assign({ ref: tableRef }, getTableProps(), { className: clsx(styles.table, styles.sticky) }, { children: [jsx(TableHeader, { instance: instance, stableColumns: stableColumns }, void 0),
                                            jsx("div", __assign({}, instance.getTableBodyProps(), { style: { width: instance.totalVisibleColumnsWidth }, className: clsx((_a = {},
                                                    _a[styles.alignItemsCenter] = data.length && alignItemsCenter,
                                                    _a)) }, { children: data.length > 0 ? (page.map(function (row) {
                                                    prepareRow(row);
                                                    return (jsx(RowSelectable, __assign({}, row.getRowProps(), { row: row, previousRow: previousRow, setPreviousRow: setPreviousRow, toggleAllRowsSelected: toggleAllRowsSelected, rows: rows }), void 0));
                                                })) : (jsx("div", __assign({ className: "p-14" }, { children: "No record found" }), void 0)) }), void 0)] }), void 0) }), void 0) }), void 0)] }), void 0) }), void 0),
                jsxs(Toolbar, __assign({ className: clsx(styles.toolbar), style: { width: mainWidth } }, { children: [selectedFlatRows.length > 0 && (jsxs("span", { children: [selectedFlatRows.length, " Selected Rows"] }, void 0)), Pagination] }), void 0)] }), void 0) }, void 0));
};

export default EnhancedTable;
//# sourceMappingURL=EnhancedTable.js.map
