import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import { TextField, InputAdornment, IconButton } from '@material-ui/core';
import React from 'react';
import { MobileDateRangePicker } from '@material-ui/lab';
import { s as styles } from '../../EnhancedTable.module-3f17e3a7.js';
import { a as getDatabaseFormatDate } from '../../moment-b7e0efe6.js';
import ClearIcon from '@material-ui/icons/Clear';
import '../../style-inject.es-1f59c1d0.js';
import '../../_commonjsHelpers-318dc0aa.js';

var DatetimePickerFilter = function (props) {
    var filterValue = props.filterValue, setFilter = props.setFilter;
    var value = [
        (filterValue === null || filterValue === void 0 ? void 0 : filterValue.from) || null,
        (filterValue === null || filterValue === void 0 ? void 0 : filterValue.to) || null,
    ];
    function clearInput(key) {
        var _a;
        var remainKey = key === 'from' ? 'to' : 'from';
        var newFilter = filterValue && filterValue[remainKey]
            ? __assign(__assign({}, filterValue), (_a = {}, _a[key] = null, _a)) : undefined;
        setFilter(newFilter);
    }
    return (jsx(MobileDateRangePicker, { startText: props.title + ' from', endText: props.title + ' to', value: value, mask: "__/__/____", inputFormat: "MM/DD/YYYY", onChange: function (_a) {
            var fromDate = _a[0], toDate = _a[1];
            return setFilter({
                from: getDatabaseFormatDate(fromDate || ''),
                to: getDatabaseFormatDate(toDate || ''),
            });
        }, renderInput: function (startProps, endProps) { return (jsxs("div", __assign({ className: "dflex" }, { children: [jsx(TextField, __assign({}, startProps, { variant: "standard", helperText: '', error: false, InputLabelProps: {
                        shrink: true,
                    }, className: styles.daterange, InputProps: {
                        endAdornment: (jsx(InputAdornment, __assign({ className: styles.adornment, position: "end", onClick: function () {
                                clearInput('from');
                            } }, { children: jsx(IconButton, __assign({ className: styles.clearBtn, "aria-label": "toggle password visibility", edge: "end" }, { children: jsx(ClearIcon, { style: { fontSize: '12px' } }, void 0) }), void 0) }), void 0)),
                    } }), void 0),
                jsx("span", __assign({ className: "invisible" }, { children: "::" }), void 0),
                jsx(TextField, __assign({}, endProps, { helperText: '', variant: "standard", error: false, InputLabelProps: { shrink: true }, className: styles.daterange, InputProps: {
                        endAdornment: (jsx(InputAdornment, __assign({ className: styles.adornment, position: "end", onClick: function () {
                                clearInput('to');
                            } }, { children: jsx(IconButton, __assign({ className: styles.clearBtn, "aria-label": "toggle password visibility", edge: "end" }, { children: jsx(ClearIcon, { style: { fontSize: '12px' } }, void 0) }), void 0) }), void 0)),
                    } }), void 0)] }), void 0)); } }, void 0));
};
var DatetimePickerFilter$1 = React.memo(DatetimePickerFilter);

export default DatetimePickerFilter$1;
//# sourceMappingURL=DatetimePickerFilter.js.map
