import { jsx } from 'react/jsx-runtime';
import React, { useState, useEffect } from 'react';
import { TextField } from '@material-ui/core';
import useDebounce from '../../utils/customHook/useDebounceValue.js';
import '../../ResizeObserver-da68295b.js';

function TextColumnFilter(props) {
    var _a = props.column, filterValue = _a.filterValue, setFilter = _a.setFilter, Header = _a.Header, id = _a.id;
    var _b = useState(filterValue || ''), value = _b[0], setValue = _b[1];
    var debouncedSearchValue = useDebounce(value, 500);
    useEffect(function () {
        if ((!filterValue && debouncedSearchValue === '') ||
            filterValue === debouncedSearchValue)
            return;
        setFilter(debouncedSearchValue || undefined);
    }, [debouncedSearchValue]);
    useEffect(function () {
        !filterValue && value !== '' && setValue('');
    }, [filterValue]);
    return (jsx(React.Fragment, { children: jsx(TextField, { fullWidth: true, type: props.type, label: props.title || Header || id, InputLabelProps: { shrink: true }, value: value, placeholder: 'All', onChange: function (e) {
                setValue(e.target.value);
            } }, void 0) }, void 0));
}

export default TextColumnFilter;
//# sourceMappingURL=TextColumnFilter.js.map
