import { d as __spreadArray, _ as __assign } from '../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import { useCallback, useEffect, useRef, useState } from 'react';
import { r as reactTable } from '../index-1c6562bc.js';
import { useSticky } from './plugins/useSticky.js';
import TableContainer from '@material-ui/core/TableContainer';
import TableToolbar from './Toolbar/TableToolbar.js';
import { s as styles } from '../EnhancedTable.module-3f17e3a7.js';
import { c as clsx } from '../clsx.m-6243b874.js';
import { S as SelectableGroup, R as RowSelectable } from '../RowSelectable-641d33ed.js';
import ReactTablePagination from './Pagination/ReactTablePagination.js';
import { C as ContextMenu, a as ContextMenuTrigger } from '../connectMenu-dd4dca1c.js';
import '../index-ae06fe64.js';
import ConditionalWrap from '../utils/ConditionalWrap.js';
import { Toolbar } from '@material-ui/core';
import { c as config } from '../config-2233d325.js';
import { useDispatch, useSelector } from 'react-redux';
import { s as selectMultiRows } from '../actions-469e4403.js';
import { g as getStorageInitialState, u as useMainResize, t as tableSelectableSelector } from '../useMainResize-11da9592.js';
import { d as debounce_1 } from '../debounce-8e349d2c.js';
import selectionHook from './plugins/selectionHook.js';
import EditableCellTextField from './EditableCell/EditableCellTextField.js';
import TableHeader from './components/TableHeader.js';
import { S as SELECTION_COLUMN_ID } from '../constants-cdb4cae7.js';
import { useLocalStorageTable } from './plugins/useLocalStorageTable.js';
import { useHiddenColumn } from './plugins/useHiddenColumn.js';
import App from '../App.js';
import '../_commonjsHelpers-318dc0aa.js';
import '@material-ui/core/Toolbar';
import './Toolbar/ColumnDisplay.js';
import '@material-ui/icons/ViewColumn';
import '@material-ui/icons/ArrowDropDown';
import '../isEqual-ff64fdde.js';
import '../_MapCache-42897023.js';
import '../_isIndex-e6cb62f4.js';
import '../style-inject.es-1f59c1d0.js';
import './Toolbar/FilterBox.js';
import '@material-ui/icons/FilterAlt';
import '../GlobalFilter-1efc032d.js';
import '@material-ui/core/styles';
import '@material-ui/core/InputBase';
import '@material-ui/core/IconButton';
import '@material-ui/icons/Search';
import '../lodash-5bd42e57.js';
import 'react-router-dom';
import '../get-45a0ceab.js';
import '../_baseSet-5f342bb5.js';
import '../useOnClickOutside-5fbcb3ab.js';
import '../ResizeObserver-da68295b.js';
import '@material-ui/icons/HighlightOff';
import './Toolbar/LocalGlobalFilter.js';
import '@material-ui/core/Tooltip/Tooltip';
import './Pagination/TablePaginationActions.js';
import '@material-ui/icons/FirstPage';
import '@material-ui/icons/KeyboardArrowLeft';
import '@material-ui/icons/KeyboardArrowRight';
import '@material-ui/icons/LastPage';
import '../TextField/AppTextField.js';
import '../Checkbox/AppCheckBox.js';
import '@material-ui/icons/Check';
import '@material-ui/icons/Remove';
import '@material-ui/icons/Edit';
import '@material-ui/icons/Clear';
import '../EditableCell.module-359afc02.js';
import '@material-ui/icons/DoneRounded';
import '../slicedToArray-cde334b7.js';
import 'react-dom';

var defaultColumn = {
    Cell: EditableCellTextField,
};
var LocalTable = function (props) {
    var _a;
    var columns = props.columns, data = props.data, rightClickMenu = props.rightClickMenu, toolbarItems = props.toolbarItems, localStorageKey = props.localStorageKey, _b = props.useSelection, useSelection = _b === void 0 ? true : _b, _c = props.useBlockingOverlay, useBlockingOverlay = _c === void 0 ? true : _c, _d = props.hasGlobalSearch, hasGlobalSearch = _d === void 0 ? true : _d, overlayConfig = props.overlayConfig, alignItemsCenter = props.alignItemsCenter;
    var initState = getStorageInitialState(localStorageKey);
    var instance = reactTable.useTable.apply(void 0, __spreadArray([{
            columns: columns,
            data: data,
            defaultColumn: defaultColumn,
            initialState: __assign({ pageIndex: 0, pageSize: config.perPage }, initState),
            pageCount: 100,
        }, reactTable.useFlexLayout,
        reactTable.useResizeColumns,
        reactTable.useFilters,
        reactTable.useColumnOrder,
        reactTable.useGlobalFilter,
        reactTable.useSortBy,
        reactTable.usePagination,
        reactTable.useRowSelect,
        useSticky,
        useLocalStorageTable,
        useHiddenColumn], (useSelection ? [selectionHook] : [])));
    var getTableProps = instance.getTableProps, prepareRow = instance.prepareRow, page = instance.page, gotoPage = instance.gotoPage, setPageSize = instance.setPageSize, selectedFlatRows = instance.selectedFlatRows, toggleAllRowsSelected = instance.toggleAllRowsSelected, rows = instance.rows, _e = instance.state, pageIndex = _e.pageIndex, pageSize = _e.pageSize;
    var mainWidth = useMainResize().width;
    var stableColumns = [SELECTION_COLUMN_ID];
    var dispatch = useDispatch();
    var delayedQuery = useCallback(debounce_1(function (rows) {
        dispatch(selectMultiRows(rows));
    }, 500), [dispatch]);
    useEffect(function () {
        var rows = selectedFlatRows.map(function (item) { return item.original; });
        delayedQuery(rows);
    }, [delayedQuery, selectedFlatRows]);
    var tableRef = useRef(null);
    useEffect(function () {
        if (tableRef.current) {
            tableRef.current.scrollIntoView({ behavior: 'smooth' });
        }
    }, [pageIndex, pageSize]);
    var Pagination = (jsx(ReactTablePagination, { gotoPage: gotoPage, pageIndex: pageIndex, setPageSize: setPageSize, pageSize: pageSize, pageTotal: data.length }, void 0));
    var isSelectable = useSelector(tableSelectableSelector);
    var _f = useState(null), previousRow = _f[0], setPreviousRow = _f[1];
    var handleSelectableGroupFinish = function (selectedRows) {
        if (selectedRows && selectedRows.length > 0) {
            selectedRows.forEach(function (row) {
                if (row && row.props) {
                    row.props.row.toggleRowSelected();
                }
            });
        }
    };
    return (jsx(App, { children: jsxs(TableContainer, __assign({ className: clsx(styles.tableContainer, useBlockingOverlay &&
                !(overlayConfig === null || overlayConfig === void 0 ? void 0 : overlayConfig.displayFullscreen) &&
                styles.positionRelative), style: { width: instance.totalVisibleColumnsWidth } }, { children: [jsx(TableToolbar, { width: mainWidth, instance: instance, stableColumns: stableColumns, toolbarItems: toolbarItems, pagination: Pagination, hasGlobalSearch: hasGlobalSearch, isLocal: true }, void 0),
                jsx("div", __assign({ className: styles.actionScroll }, { children: jsxs(SelectableGroup, __assign({ className: styles.fixWidthScroll, disabled: isSelectable, deselectOnEsc: true, selectOnClick: false, enableDeselect: true, allowClickWithoutSelected: false, tolerance: 5, resetOnStart: true, onSelectionFinish: handleSelectableGroupFinish, ignoreList: ['.th'] }, { children: [rightClickMenu && (jsx(ContextMenu, __assign({ id: "same_unique_identifier", className: styles.contextMenu }, { children: rightClickMenu }), void 0)),
                            jsx("div", __assign({ className: clsx(styles.tableBodyScroll, styles.noHighLight) }, { children: jsx(ConditionalWrap, __assign({ condition: !!rightClickMenu, wrap: function (children) { return (jsx(ContextMenuTrigger, __assign({ id: 'same_unique_identifier', holdToDisplay: -1 }, { children: children }), void 0)); } }, { children: jsxs("div", __assign({ ref: tableRef }, getTableProps(), { className: clsx(styles.table, styles.sticky) }, { children: [jsx(TableHeader, { instance: instance, stableColumns: stableColumns }, void 0),
                                            jsx("div", __assign({}, instance.getTableBodyProps(), { style: { width: instance.totalVisibleColumnsWidth }, className: clsx((_a = {},
                                                    _a[styles.alignItemsCenter] = data.length && alignItemsCenter,
                                                    _a)) }, { children: data.length > 0 ? (page.map(function (row) {
                                                    prepareRow(row);
                                                    return (jsx(RowSelectable, __assign({}, row.getRowProps(), { row: row, previousRow: previousRow, setPreviousRow: setPreviousRow, toggleAllRowsSelected: toggleAllRowsSelected, rows: rows }), void 0));
                                                })) : (jsx("div", __assign({ className: "p-14" }, { children: "No record found" }), void 0)) }), void 0)] }), void 0) }), void 0) }), void 0)] }), void 0) }), void 0),
                jsxs(Toolbar, __assign({ className: clsx(styles.toolbar), style: { width: mainWidth } }, { children: [selectedFlatRows.length > 0 && (jsxs("span", { children: [selectedFlatRows.length, " Selected Rows"] }, void 0)), Pagination] }), void 0)] }), void 0) }, void 0));
};

export default LocalTable;
//# sourceMappingURL=LocalTable.js.map
