import { _ as __assign, d as __spreadArray } from '../../tslib.es6-a941f97f.js';
import { jsxs, jsx } from 'react/jsx-runtime';
import { useMemo } from 'react';
import TablePaginationActions from './TablePaginationActions.js';
import { s as styleInject } from '../../style-inject.es-1f59c1d0.js';
import AppTextField from '../../TextField/AppTextField.js';
import { Autocomplete, MenuItem } from '@material-ui/core';
import '@material-ui/icons/FirstPage';
import '@material-ui/core/IconButton';
import '@material-ui/icons/KeyboardArrowLeft';
import '@material-ui/icons/KeyboardArrowRight';
import '@material-ui/icons/LastPage';
import '@material-ui/core/styles';

var css_248z = ".ReactTablePagination-module_pagination__2HMvs {\n  display: inline-flex;\n  align-items: center;\n  font-size: 1.2rem;\n  color: #101C36;\n  mix-blend-mode: normal;\n  opacity: 0.54; }\n\n.ReactTablePagination-module_inputForm__RQa7G {\n  margin-right: 10px;\n  display: inline-flex;\n  align-items: center; }\n  .ReactTablePagination-module_inputForm__RQa7G input {\n    max-width: 50px;\n    font-size: 12px; }\n  .ReactTablePagination-module_inputForm__RQa7G .ReactTablePagination-module_selectInput__30bhx {\n    font-size: 12px; }\n\n.ReactTablePagination-module_selectOption__12FPK {\n  justify-content: center;\n  padding-right: 0;\n  padding-left: 0; }\n\n.ReactTablePagination-module_selection__2-QnA {\n  font-size: 1.2rem;\n  margin-right: 1rem;\n  margin-left: 0;\n  display: flex;\n  align-items: center; }\n\n.ReactTablePagination-module_selectIcon__1yJN2 {\n  font-size: 2rem; }\n";
var styles = {"pagination":"ReactTablePagination-module_pagination__2HMvs","inputForm":"ReactTablePagination-module_inputForm__RQa7G","selectInput":"ReactTablePagination-module_selectInput__30bhx","selectOption":"ReactTablePagination-module_selectOption__12FPK","selection":"ReactTablePagination-module_selection__2-QnA","selectIcon":"ReactTablePagination-module_selectIcon__1yJN2"};
styleInject(css_248z);

var ReactTablePagination = function (props) {
    var gotoPage = props.gotoPage, setPageSize = props.setPageSize, pageIndex = props.pageIndex, pageSize = props.pageSize, pageTotal = props.pageTotal;
    var firstRow = pageIndex * pageSize + 1 || 0;
    var lastRow = Math.min(pageIndex * pageSize + pageSize, pageTotal) || 0;
    var pageOptions = useMemo(function () {
        var defaultOptions = [
            { label: '5', value: 5 },
            { label: '10', value: 10 },
            { label: '25', value: 25 },
            { label: '50', value: 50 },
            { label: 'All', value: pageTotal },
        ];
        if (defaultOptions.every(function (item) { return item.value !== pageSize; })) {
            defaultOptions.unshift({
                label: pageSize.toString(),
                value: pageSize,
            });
        }
        return defaultOptions;
    }, [pageSize, pageTotal]);
    var initPageSize = {
        label: pageSize.toString(),
        value: pageSize,
    };
    var handleChangePage = function (event, page) {
        gotoPage(page);
    };
    return pageTotal ? (jsxs("span", __assign({ className: styles.pagination }, { children: [jsxs("span", __assign({ className: styles.inputForm }, { children: [jsx("span", { children: "Show" }, void 0), ":", ' ', jsx(Autocomplete, { value: initPageSize, onChange: function (event, newValue) {
                            var newSize = typeof newValue === 'string' ? newValue : newValue.value;
                            setPageSize(Number(newSize));
                        }, filterOptions: function (options, params) {
                            var filtered = __spreadArray([], options);
                            if (params.inputValue !== '' &&
                                options.every(function (item) { return Number(item.label) !== Number(params.inputValue); })) {
                                filtered.unshift({
                                    value: Number(params.inputValue),
                                    inputValue: params.inputValue,
                                    label: params.inputValue,
                                });
                            }
                            return filtered;
                        }, getOptionLabel: function (option) { return (option === null || option === void 0 ? void 0 : option.label) || ''; }, disableClearable: true, handleHomeEndKeys: true, blurOnSelect: true, clearOnBlur: true, selectOnFocus: true, freeSolo: true, options: pageOptions, renderOption: function (props, option) { return (jsx(MenuItem, __assign({}, props, { className: 'd-flex justify-content-center' }, { children: option.label }), void 0)); }, renderInput: function (params) { return jsx(AppTextField, __assign({}, params), void 0); }, classes: {
                            option: styles.selectOption,
                        } }, void 0)] }), void 0),
            jsxs("span", { children: [firstRow, "-", lastRow, " of ", pageTotal] }, void 0),
            jsx(TablePaginationActions, { count: pageTotal || 0, getItemAriaLabel: function () { return ''; }, onPageChange: handleChangePage, page: pageIndex, rowsPerPage: pageSize, showFirstButton: true, showLastButton: true }, void 0)] }), void 0)) : (jsx("span", {}, void 0));
};

export default ReactTablePagination;
//# sourceMappingURL=ReactTablePagination.js.map
