import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsxs, jsx } from 'react/jsx-runtime';
import FirstPageIcon from '@material-ui/icons/FirstPage';
import IconButton from '@material-ui/core/IconButton';
import KeyboardArrowLeft from '@material-ui/icons/KeyboardArrowLeft';
import KeyboardArrowRight from '@material-ui/icons/KeyboardArrowRight';
import LastPageIcon from '@material-ui/icons/LastPage';
import { makeStyles, useTheme } from '@material-ui/core/styles';

var useStyles = makeStyles(function (theme) { return ({
    root: {
        flexShrink: 0,
        marginLeft: '10px',
    },
    button: {
        padding: 0,
    },
}); });
var TablePaginationActions = function (props) {
    var classes = useStyles();
    var theme = useTheme();
    var count = props.count, page = props.page, rowsPerPage = props.rowsPerPage, onPageChange = props.onPageChange;
    var handleFirstPageButtonClick = function (event) {
        onPageChange(event, 0);
    };
    var handleBackButtonClick = function (event) {
        onPageChange(event, page - 1);
    };
    var handleNextButtonClick = function (event) {
        onPageChange(event, page + 1);
    };
    var handleLastPageButtonClick = function (event) {
        onPageChange(event, Math.max(0, Math.ceil(count / rowsPerPage) - 1));
    };
    return (jsxs("div", __assign({ className: classes.root }, { children: [jsx(IconButton, __assign({ onClick: handleFirstPageButtonClick, className: classes.button, disabled: page === 0, "aria-label": "first page" }, { children: theme.direction === 'rtl' ? jsx(LastPageIcon, {}, void 0) : jsx(FirstPageIcon, {}, void 0) }), void 0),
            jsx(IconButton, __assign({ className: classes.button, onClick: handleBackButtonClick, disabled: page === 0, "aria-label": "previous page" }, { children: theme.direction === 'rtl' ? (jsx(KeyboardArrowRight, {}, void 0)) : (jsx(KeyboardArrowLeft, {}, void 0)) }), void 0),
            jsx(IconButton, __assign({ onClick: handleNextButtonClick, className: classes.button, disabled: page >= Math.ceil(count / rowsPerPage) - 1, "aria-label": "next page" }, { children: theme.direction === 'rtl' ? (jsx(KeyboardArrowLeft, {}, void 0)) : (jsx(KeyboardArrowRight, {}, void 0)) }), void 0),
            jsx(IconButton, __assign({ onClick: handleLastPageButtonClick, disabled: page >= Math.ceil(count / rowsPerPage) - 1, className: classes.button, "aria-label": "last page" }, { children: theme.direction === 'rtl' ? jsx(FirstPageIcon, {}, void 0) : jsx(LastPageIcon, {}, void 0) }), void 0)] }), void 0));
};

export default TablePaginationActions;
//# sourceMappingURL=TablePaginationActions.js.map
