import { _ as __assign, d as __spreadArray } from '../../tslib.es6-a941f97f.js';
import { jsxs, jsx } from 'react/jsx-runtime';
import React from 'react';
import { Popover, FormControlLabel, Checkbox } from '@material-ui/core';
import { s as styles } from '../../EnhancedTable.module-3f17e3a7.js';
import { c as clsx } from '../../clsx.m-6243b874.js';
import AppColumnsIcon from '@material-ui/icons/ViewColumn';
import ArrowDropDownIcon from '@material-ui/icons/ArrowDropDown';
import { S as SELECTION_COLUMN_ID } from '../../constants-cdb4cae7.js';
import { l as isEqual_1 } from '../../isEqual-ff64fdde.js';
import '../../style-inject.es-1f59c1d0.js';
import '../../_MapCache-42897023.js';
import '../../_commonjsHelpers-318dc0aa.js';
import '../../_isIndex-e6cb62f4.js';

var ColumnDisplay = function (props) {
    var stableColumns = props.stableColumns, instance = props.instance, defaultHiddenColumns = props.defaultHiddenColumns;
    var _a = props.instance, allColumns = _a.allColumns, state = _a.state, setColumnOrder = _a.setColumnOrder;
    var columnOrder = state.columnOrder, leftStickyColumns = state.leftStickyColumns;
    var _b = React.useState(null), anchorEl = _b[0], setAnchorEl = _b[1];
    var handleClick = function (event) {
        setAnchorEl(event.currentTarget);
    };
    var handleClose = function () {
        setAnchorEl(null);
    };
    function isDisableColumn(column) {
        return stableColumns.includes(column.id) || !column.Header;
    }
    var isShowAll = instance.visibleColumns.length === allColumns.length;
    function toggleAll(event) {
        if (event.target.checked) {
            instance.setHiddenColumns([]);
        }
        else {
            instance.setHiddenColumns(allColumns
                .map(function (item) { return item.id; })
                .filter(function (index) { return !stableColumns.includes(index); }));
        }
    }
    function priorityLeftStickyReorder() {
        var newColumnOrder = Array.from(new Set(__spreadArray(__spreadArray([SELECTION_COLUMN_ID], columnOrder), leftStickyColumns)));
        newColumnOrder = newColumnOrder.sort(function (a, b) {
            return Number(leftStickyColumns.includes(b)) -
                Number(leftStickyColumns.includes(a));
        });
        if (!isEqual_1(newColumnOrder, columnOrder)) {
            setColumnOrder(newColumnOrder);
        }
    }
    var open = Boolean(anchorEl);
    return (jsxs(React.Fragment, { children: [jsxs("span", __assign({ className: styles.action, onClick: handleClick }, { children: [jsx(AppColumnsIcon, { className: styles.iconColumns }, void 0),
                    jsx("span", { children: "COLUMNS" }, void 0),
                    jsx(ArrowDropDownIcon, { className: styles.iconDown }, void 0)] }), void 0),
            jsx(Popover, __assign({ open: open, anchorEl: anchorEl, onClose: handleClose, anchorOrigin: {
                    vertical: 'bottom',
                    horizontal: 'right',
                }, transformOrigin: {
                    vertical: 'top',
                    horizontal: 'left',
                } }, { children: jsxs("div", __assign({ className: styles.popover }, { children: [jsxs("div", { children: [jsx(FormControlLabel, { title: 'Toggle column visibility', control: jsx(Checkbox, { color: "primary", checked: isShowAll, indeterminate: !isShowAll && !instance.allColumnsHidden, onChange: function (event) {
                                            toggleAll(event);
                                            if (event.target.checked) {
                                                priorityLeftStickyReorder();
                                            }
                                        } }, void 0), label: jsx("span", __assign({ className: "primary-text" }, { children: "All" }), void 0) }, void 0),
                                jsx("span", __assign({ className: styles.clearOrderTag, onClick: function () {
                                        instance.setColumnOrder([]);
                                        instance.resetAllStickyColumns();
                                        if (Array.isArray(defaultHiddenColumns) &&
                                            defaultHiddenColumns.length > 0) {
                                            instance.setHiddenColumns(defaultHiddenColumns);
                                        }
                                    }, title: 'Reset the order of table columns' }, { children: "Reset Order" }), void 0)] }, void 0),
                        allColumns
                            .filter(function (column) { return !column.isHidden; })
                            .map(function (column) { return (jsx("div", { children: jsx(FormControlLabel, { className: clsx(isDisableColumn(column) && 'displayNone'), control: jsx(Checkbox, __assign({}, column.getToggleHiddenProps(), { checked: column.isVisible, onChange: function (event) {
                                        column.toggleHidden();
                                        if (event.target.checked) {
                                            priorityLeftStickyReorder();
                                        }
                                    }, color: "primary" }), void 0), label: typeof column.Header === 'string'
                                    ? column.Header
                                    : column.id }, void 0) }, column.id)); }),
                        jsx("br", {}, void 0)] }), void 0) }), void 0)] }, void 0));
};
var ColumnDisplay$1 = React.memo(ColumnDisplay);

export default ColumnDisplay$1;
//# sourceMappingURL=ColumnDisplay.js.map
