import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsxs, jsx } from 'react/jsx-runtime';
import React, { useState } from 'react';
import { Popover, Button } from '@material-ui/core';
import { s as styles } from '../../EnhancedTable.module-3f17e3a7.js';
import AppFilterIcon from '@material-ui/icons/FilterAlt';
import { c as clsx } from '../../clsx.m-6243b874.js';
import '../../style-inject.es-1f59c1d0.js';

var FilterBox = function (props) {
    var _a = props.instance, allColumns = _a.allColumns, state = _a.state, setAllFilters = _a.setAllFilters;
    var filterLength = state.filters.length;
    var hasFilter = !!allColumns.filter(function (column) { return column.filter; }).length;
    var _b = React.useState(null), anchorEl = _b[0], setAnchorEl = _b[1];
    var _c = useState(true), hidden = _c[0], setHidden = _c[1];
    var handleClick = function (event) {
        setAnchorEl(event.currentTarget);
        setHidden(false);
    };
    var handleClose = function () {
        setHidden(true);
    };
    function resetFilter() {
        setAllFilters([]);
    }
    var open = Boolean(anchorEl);
    return hasFilter ? (jsxs(React.Fragment, { children: [jsxs("span", __assign({ className: styles.action, onClick: handleClick }, { children: [jsx(AppFilterIcon, { className: styles.iconFilter }, void 0),
                    jsxs("span", { children: ["FILTER ", filterLength > 0 && '(' + filterLength + ')'] }, void 0)] }), void 0),
            jsx(Popover, __assign({ className: clsx(hidden && 'hidden'), open: open, anchorEl: anchorEl, onClose: handleClose, anchorOrigin: {
                    vertical: 'bottom',
                    horizontal: 'left',
                }, transformOrigin: {
                    vertical: 'top',
                    horizontal: 'left',
                } }, { children: jsxs("div", __assign({ className: clsx(styles.popover, styles.filterPopover) }, { children: [jsxs("div", __assign({ className: styles.filterLabel }, { children: [jsxs("span", { children: ["Applied Filters: ", jsx("strong", { children: filterLength }, void 0), ' '] }, void 0),
                                filterLength > 0 && (jsx(Button, __assign({ className: styles.resetBtn, onClick: resetFilter, variant: "contained", color: 'primary' }, { children: "Remove" }), void 0))] }), void 0),
                        jsx("div", __assign({ className: styles.filterContent }, { children: allColumns
                                .filter(function (columns) { return columns.filter; })
                                .sort(function (a, b) {
                                var x = a.filterOrder || 0;
                                var y = b.filterOrder || 0;
                                return !x - !y || +(x > y) || -(x < y);
                            })
                                .map(function (column) { return (jsx("div", __assign({ className: styles.filterItem }, { children: column.render('Filter') }), column.id)); }) }), void 0)] }), void 0) }), void 0)] }, void 0)) : null;
};
var FilterBox$1 = React.memo(FilterBox);

export default FilterBox$1;
//# sourceMappingURL=FilterBox.js.map
