import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsxs, jsx } from 'react/jsx-runtime';
import { useState, useRef, useCallback } from 'react';
import { makeStyles, createStyles } from '@material-ui/core/styles';
import InputBase from '@material-ui/core/InputBase';
import IconButton from '@material-ui/core/IconButton';
import SearchIcon from '@material-ui/icons/Search';
import { c as clsx } from '../../clsx.m-6243b874.js';
import { l as lodash } from '../../lodash-5bd42e57.js';
import { u as useOnClickOutside } from '../../useOnClickOutside-5fbcb3ab.js';
import Tooltip from '@material-ui/core/Tooltip/Tooltip';
import HighlightOffIcon from '@material-ui/icons/HighlightOff';
import '../../_commonjsHelpers-318dc0aa.js';

var useStyles = makeStyles(function (theme) {
    return createStyles({
        root: {
            display: 'inline-flex',
            alignItems: 'center',
            transition: 'width 0.75s cubic-bezier(0.000, 0.795, 0.000, 1.000)',
            padding: '1px 3px',
        },
        open: {
            border: '1px solid #38B4C9',
            borderRadius: '50px',
            '& input': {
                marginLeft: 15,
            },
        },
        input: {
            flex: 1,
            transition: 'all 0.75s cubic-bezier(0.000, 0.795, 0.000, 1.000)',
        },
        iconButton: {
            padding: 10,
            color: '#38B4C9',
            fontSize: '16px',
        },
        hide: {
            width: 0,
            transition: 'all 0.75s cubic-bezier(0.000, 0.795, 0.000, 1.000)',
        },
    });
});
function LocalGlobalFilter(_a) {
    var globalFilter = _a.globalFilter, setGlobalFilter = _a.setGlobalFilter;
    var classes = useStyles();
    var _b = useState(globalFilter || ''), inputValue = _b[0], setInputValue = _b[1];
    var _c = useState(!!inputValue), open = _c[0], setOpen = _c[1];
    var ref = useRef(null);
    var divRef = useRef(null);
    useOnClickOutside(divRef, function () { return close(); });
    var delayedQuery = useCallback(lodash.debounce(function (q) {
        setGlobalFilter(q || undefined);
    }, 200), []);
    function onChange(event) {
        var value = event.currentTarget.value;
        setInputValue(value);
        delayedQuery(value);
    }
    function onClick() {
        setOpen(!open);
        if (ref && ref.current) {
            ref.current.focus();
        }
    }
    function close() {
        if (!inputValue) {
            setOpen(false);
        }
    }
    function clear() {
        setInputValue('');
        delayedQuery.cancel();
        setGlobalFilter(undefined);
        setOpen(false);
    }
    return (jsxs("div", __assign({ ref: divRef, className: clsx(classes.root, open && classes.open) }, { children: [jsx(InputBase, { inputRef: ref, value: inputValue, onChange: onChange, className: clsx(classes.input, !open && classes.hide), placeholder: "Search in Table" }, void 0),
            !inputValue ? (jsx(Tooltip, __assign({ title: 'Search in Table' }, { children: jsx(IconButton, __assign({ onClick: onClick, className: classes.iconButton, "aria-label": "menu" }, { children: jsx(SearchIcon, { style: { fontSize: '20px' } }, void 0) }), void 0) }), void 0)) : (jsx(Tooltip, __assign({ title: 'Clear' }, { children: jsx(IconButton, __assign({ onClick: clear, className: classes.iconButton, "aria-label": "menu" }, { children: jsx(HighlightOffIcon, { style: { fontSize: '20px' } }, void 0) }), void 0) }), void 0))] }), void 0));
}

export default LocalGlobalFilter;
//# sourceMappingURL=LocalGlobalFilter.js.map
