import { Switch } from '@material-ui/core';
import { withStyles, createStyles } from '@material-ui/core/styles';

var AntSwitch = withStyles(function (theme) {
    return createStyles({
        root: {
            width: 32,
            height: 16,
            padding: 0,
            display: 'flex',
        },
        switchBase: {
            padding: 2,
            color: '#75C5B6',
            '& + $track': {
                opacity: 1,
                backgroundColor: theme.palette.common.white,
                borderColor: theme.palette.primary.main,
            },
            '&$checked': {
                color: '#75C5B6',
                transform: 'translateX(15px)',
                '& + $track': {
                    opacity: 1,
                    backgroundColor: theme.palette.common.white,
                    borderColor: theme.palette.primary.main,
                },
            },
        },
        thumb: {
            width: 12,
            height: 12,
            boxShadow: 'none',
        },
        track: {
            border: "1px solid " + theme.palette.grey[500],
            borderRadius: 16 / 2,
            opacity: 1,
            backgroundColor: theme.palette.common.white,
        },
        checked: {},
    });
})(Switch);

export default AntSwitch;
//# sourceMappingURL=AntSwitch.js.map
