import { c as __rest, _ as __assign } from '../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import { MenuItem } from '@material-ui/core';
import React from 'react';
import AppTextField from './AppTextField.js';
import '../style-inject.es-1f59c1d0.js';

function AppSelectField(props) {
    var label = props.label, filterValue = props.filterValue, setFilter = props.setFilter, _a = props.valueKey, valueKey = _a === void 0 ? 'id' : _a, _b = props.labelKey, labelKey = _b === void 0 ? 'name' : _b, textProp = __rest(props, ["label", "filterValue", "setFilter", "valueKey", "labelKey"]);
    var options = props.options;
    if (Array.isArray(options)) {
        options = options.reduce(function (obj, item) {
            if (item[valueKey]) {
                obj[item[valueKey]] = item[labelKey];
            }
            else {
                obj[item] = item;
            }
            return obj;
        }, {});
    }
    return (jsx(React.Fragment, { children: jsxs(AppTextField, __assign({ select: true, fullWidth: true, label: label, InputLabelProps: { shrink: true }, value: filterValue === undefined ? 'none' : filterValue, onChange: function (e) {
                var value = e.target.value === 'none' ? undefined : e.target.value;
                setFilter(value);
            }, SelectProps: {
                MenuProps: {
                    anchorOrigin: {
                        vertical: 'bottom',
                        horizontal: 'left',
                    },
                    getContentAnchorEl: null,
                },
            } }, textProp, { children: [textProp.placeholder && (jsx(MenuItem, __assign({ className: props.className, style: { opacity: 0.5 }, value: "none" }, { children: textProp.placeholder }), void 0)),
                Object.keys(options).map(function (value) { return (jsx(MenuItem, __assign({ className: props.className, value: value }, { children: options[value] }), value)); })] }), void 0) }, void 0));
}

export default AppSelectField;
//# sourceMappingURL=AppSelectField.js.map
