import { c as __rest, _ as __assign } from '../tslib.es6-a941f97f.js';
import { jsx } from 'react/jsx-runtime';
import AppTextField from './AppTextField.js';
import { a as useFormikContext } from '../formik.esm-4665f351.js';
import { g as get_1 } from '../get-45a0ceab.js';
import { _ as _baseSet } from '../_baseSet-5f342bb5.js';
import '@material-ui/core';
import '../style-inject.es-1f59c1d0.js';
import 'react';
import '../hoist-non-react-statics.cjs-01a5a501.js';
import '../_commonjsHelpers-318dc0aa.js';
import '../_MapCache-42897023.js';
import '../_isIndex-e6cb62f4.js';

/**
 * Sets the value at `path` of `object`. If a portion of `path` doesn't exist,
 * it's created. Arrays are created for missing index properties while objects
 * are created for all other missing properties. Use `_.setWith` to customize
 * `path` creation.
 *
 * **Note:** This method mutates `object`.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to modify.
 * @param {Array|string} path The path of the property to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns `object`.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.set(object, 'a[0].b.c', 4);
 * console.log(object.a[0].b.c);
 * // => 4
 *
 * _.set(object, ['x', '0', 'y', 'z'], 5);
 * console.log(object.x[0].y.z);
 * // => 5
 */
function set(object, path, value) {
  return object == null ? object : _baseSet(object, path, value);
}

var set_1 = set;

var AppValidateField = function (props) {
    var validation = useFormikContext();
    var errors = validation.errors, touched = validation.touched, handleBlur = validation.handleBlur, handleChange = validation.handleChange, values = validation.values, status = validation.status, setStatus = validation.setStatus;
    var name = props.name || 'name';
    var error = get_1(touched, name)
        ? get_1(status, name) || get_1(errors, name)
        : '';
    var helperText = props.helperText, otherProps = __rest(props, ["helperText"]);
    function onChange(event) {
        var _a, _b;
        var max = (_b = (_a = props.InputProps) === null || _a === void 0 ? void 0 : _a.inputProps) === null || _b === void 0 ? void 0 : _b.max;
        if (props.type === 'number' &&
            max &&
            Number(event.target.value) > Number(max))
            return;
        var newStatus = __assign({}, status);
        if (get_1(status, name)) {
            set_1(newStatus, name, '');
            setStatus(newStatus);
        }
        handleChange(event);
    }
    return (jsx(AppTextField, __assign({ name: name, error: !!error, onChange: onChange, onBlur: handleBlur, value: get_1(values, name), helperText: error ? error : helperText }, otherProps), void 0));
};

export default AppValidateField;
//# sourceMappingURL=AppValidateField.js.map
