import { c as __rest, _ as __assign } from '../tslib.es6-a941f97f.js';
import { jsxs, jsx } from 'react/jsx-runtime';
import { useMemo } from 'react';
import { a as useFormikContext } from '../formik.esm-4665f351.js';
import { makeStyles } from '@material-ui/core/styles';
import { Grid, Slider, Input } from '@material-ui/core';
import { g as get_1 } from '../get-45a0ceab.js';
import { d as debounce_1 } from '../debounce-8e349d2c.js';
import '../hoist-non-react-statics.cjs-01a5a501.js';
import '../_commonjsHelpers-318dc0aa.js';
import '../_MapCache-42897023.js';

var makeSliderStyles = makeStyles(function (theme) { return ({
    track: {
        height: 4,
    },
    rail: {
        height: 4,
    },
    thumb: {
        marginTop: -4,
        boxShadow: '0px 1px 5px rgba(45, 166, 186, 0.12), 0px 3px 1px rgba(45, 166, 186, 0.2), 0px 2px 4px rgba(45, 166, 186, 0.14)',
    },
    mark: {
        display: 'none',
    },
}); });
var AppValidateSlider = function (props) {
    var _a;
    var sliderStyles = makeSliderStyles();
    var _b = useFormikContext(), values = _b.values, setFieldValue = _b.setFieldValue, setFieldTouched = _b.setFieldTouched, errors = _b.errors, touched = _b.touched;
    var name = props.name || 'name';
    props.inputStep; props.useInput; var onValueChangeHandler = props.onValueChangeHandler, sliderProps = __rest(props, ["inputStep", "useInput", "onValueChangeHandler"]);
    var minRange = props.min != null ? props.min : 0;
    var maxRange = props.max != null ? props.max : 100;
    var stepRange = props.step != null ? props.step : 1;
    var ariaLabelledBy = (_a = props['aria-labelledby']) !== null && _a !== void 0 ? _a : 'input-slider';
    var error = useMemo(function () {
        return get_1(touched, name) ? get_1(errors, name) : '';
    }, [touched, name, errors]);
    var handleSliderChange = function (event, newValue) {
        if (!get_1(touched, name)) {
            setFieldTouched(name);
        }
        if (Array.isArray(newValue)) {
            setFieldValue(name, newValue[0]);
        }
        if (typeof newValue === 'number') {
            setFieldValue(name, newValue);
        }
    };
    var handleInputChange = function (event) {
        if (!get_1(touched, name)) {
            setFieldTouched(name);
        }
        var value = Number(event.target.value);
        handleValueChange(Number.isNaN(value) ? 0 : value);
    };
    var callbackHandler = debounce_1(function (newValue) {
        if (!onValueChangeHandler)
            return;
        return onValueChangeHandler(newValue, name, setFieldValue);
    }, 100);
    var handleValueChange = function (newValue) {
        setFieldValue(name, newValue);
        callbackHandler(newValue);
    };
    var handleSliderMouseUp = function (event, newValue) {
        var value = Array.isArray(newValue) ? newValue[0] : newValue;
        handleValueChange(value);
    };
    var handleInputBlur = function () {
        var value = get_1(values, name);
        if (value < minRange) {
            setFieldValue(name, minRange);
        }
        else if (value > maxRange) {
            setFieldValue(name, maxRange);
        }
    };
    return (jsxs(Grid, __assign({ container: true, spacing: 2, alignItems: "center" }, { children: [jsx(Grid, __assign({ item: true, xs: props.useInput ? 9 : 12 }, { children: jsx(Slider, __assign({}, sliderProps, { value: get_1(values, name), min: minRange, max: maxRange, step: stepRange, "aria-labelledby": ariaLabelledBy, component: "span", classes: sliderProps.classes || sliderStyles, onChange: handleSliderChange, onChangeCommitted: handleSliderMouseUp }), void 0) }), void 0),
            props.useInput && (jsx(Grid, __assign({ item: true, xs: 3 }, { children: jsx(Input, { value: get_1(values, name), margin: "dense", onChange: handleInputChange, onBlur: handleInputBlur, style: { transform: 'translateY(-25px)' }, inputProps: {
                        step: props.inputStep || stepRange,
                        min: minRange,
                        max: maxRange,
                        type: 'number',
                        'aria-labelledby': ariaLabelledBy,
                    } }, void 0) }), void 0)),
            error && (jsx(Grid, __assign({ item: true, xs: 12, className: "pt-0" }, { children: jsx("p", __assign({ className: "error text-3" }, { children: error }), void 0) }), void 0))] }), void 0));
};

export default AppValidateSlider;
//# sourceMappingURL=AppValidateSlider.js.map
