import { _ as _extends } from './index-c883ae0c.js';
import { _ as _objectWithoutPropertiesLoose } from './emotion-element-547f2a0a.esm-f471089a.js';
import { h as propToStyleFunction } from './experimentalStyled-899ca16e.js';

const splitProps = props => {
  const result = {
    systemProps: {},
    otherProps: {}
  };
  Object.keys(props).forEach(prop => {
    if (propToStyleFunction[prop]) {
      result.systemProps[prop] = props[prop];
    } else {
      result.otherProps[prop] = props[prop];
    }
  });
  return result;
};

function extendSxProp(props) {
  const {
    sx: inSx
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["sx"]);

  const {
    systemProps,
    otherProps
  } = splitProps(other);
  return _extends({}, otherProps, {
    sx: _extends({}, systemProps, inSx)
  });
}

export { extendSxProp as e };
//# sourceMappingURL=extendSxProp-0d70e009.js.map
