import { useState, useEffect } from 'react';
import { R as ResizeObserver_2 } from './ResizeObserver-da68295b.js';

var tableSelectableSelector = function (state) {
    return state.reactTable.isSelectable;
};

function getStorageInitialState(localStorageKey) {
    var initState = {};
    var showColumn = localStorage.getItem(localStorageKey + '_columnOrder')
        ? JSON.parse(localStorage.getItem(localStorageKey + '_columnOrder'))
        : undefined;
    if (showColumn)
        initState['columnOrder'] = showColumn;
    var hideColumn = localStorage.getItem(localStorageKey + '_hiddenColumns')
        ? JSON.parse(localStorage.getItem(localStorageKey + '_hiddenColumns'))
        : undefined;
    if (hideColumn)
        initState['hiddenColumns'] = hideColumn;
    return initState;
}

function useMainResize() {
    var main = document.getElementById('main');
    var _a = useState({
        width: (main === null || main === void 0 ? void 0 : main.offsetWidth) || 0,
        height: (main === null || main === void 0 ? void 0 : main.offsetHeight) || 0,
    }), dimensions = _a[0], setDimensions = _a[1];
    useEffect(function () {
        var ro = new ResizeObserver_2(function (entries) {
            if (main) {
                var getDimensions = function () { return ({
                    width: (main === null || main === void 0 ? void 0 : main.offsetWidth) || 0,
                    height: (main === null || main === void 0 ? void 0 : main.offsetHeight) || 0,
                }); };
                setDimensions(getDimensions());
            }
        });
        if (main) {
            ro.observe(main);
        }
        return function () {
            if (ro) {
                ro.disconnect();
            }
        };
    }, [main]);
    return dimensions;
}

export { getStorageInitialState as g, tableSelectableSelector as t, useMainResize as u };
//# sourceMappingURL=useMainResize-11da9592.js.map
