import { useState, useEffect } from 'react';

function useDebounce(value, delay) {
    var _a = useState(value), debouncedValue = _a[0], setDebouncedValue = _a[1];
    useEffect(function () {
        var handler = setTimeout(function () {
            setDebouncedValue(value);
        }, delay);
        return function () {
            clearTimeout(handler);
        };
    }, [delay, value]);
    return debouncedValue;
}

export default useDebounce;
//# sourceMappingURL=useDebounceValue.js.map
